unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  Gorilla.Viewport, System.Math.Vectors, FMX.Types3D, FMX.Objects3D,
  FMX.Controls3D, Gorilla.Control, Gorilla.Mesh, Gorilla.Plane, Gorilla.Cube,
  Gorilla.Sphere, Gorilla.Material.Phong, Gorilla.Material.Default,
  Gorilla.Material.Lambert, FMX.MaterialSources, Gorilla.Physics, Gorilla.DefTypes,
  FMX.Controls.Presentation, FMX.StdCtrls, Gorilla.Transform,
  Gorilla.Material.POM, Gorilla.Material.PBR, Gorilla.Material.Blinn;

type
  TForm1 = class(TForm)
    GorillaViewport1: TGorillaViewport;
    Camera1: TCamera;
    Light1: TLight;
    Dummy1: TDummy;
    GorillaSphere1: TGorillaSphere;
    GorillaCube1: TGorillaCube;
    LightMaterialSource1: TLightMaterialSource;
    GorillaLambertMaterialSource1: TGorillaLambertMaterialSource;
    GorillaPhysicsSystem1: TGorillaPhysicsSystem;
    Timer1: TTimer;
    Label1: TLabel;
    Button1: TButton;
    GorillaBlinnMaterialSource1: TGorillaBlinnMaterialSource;
    GorillaCube2: TGorillaCube;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}


uses
  System.IOUtils,
  Gorilla.Physics.Q3.Body;

procedure TForm1.FormCreate(Sender: TObject);
var LPath : String;
    LPrefab : TGorillaColliderSettings;
begin
  LPath := '';
{$IFDEF ANDROID}
  LPath := IncludeTrailingPathDelimiters(TPath.GetHomePath());
{$ENDIF}

  // load textures for plane, cube and sphere
  LightMaterialSource1.Texture.LoadFromFile(LPath + 'crate1_diffuse.png');
  GorillaLambertMaterialSource1.Texture.LoadFromFile(LPath + 'floor-wood.jpg');
  GorillaBlinnMaterialSource1.Texture.LoadFromFile(LPath + 'candycane.jpg');

  GorillaPhysicsSystem1.SetSize(100, 100, 100);

  // create a static collider for the plane
  LPrefab := TGorillaColliderSettings.Create(TQ3BodyType.eStaticBody);
  GorillaPhysicsSystem1.AddBoxCollider(GorillaCube2, LPrefab);

  // create a collider for the cube
  LPrefab := TGorillaColliderSettings.Create(TQ3BodyType.eDynamicBody);
  GorillaPhysicsSystem1.AddBoxCollider(GorillaCube1, LPrefab);

  // create a collider for the sphere
  LPrefab := TGorillaColliderSettings.Create(TQ3BodyType.eDynamicBody);
  GorillaPhysicsSystem1.AddSphereCollider(GorillaSphere1, LPrefab);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // we activate the physics system
  GorillaPhysicsSystem1.Active := true;
  // and we need to activate the physics timer for constant updates
  Timer1.Enabled := true;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
var LImpulse : TPoint3D;
begin
  if KeyChar = 'c' then
  begin
    ShowMessage((GorillaLambertMaterialSource1.Material as TGorillaLambertMaterial).VertexShaderNode.ToString());
    ShowMessage((GorillaLambertMaterialSource1.Material as TGorillaLambertMaterial).FragmentShaderNode.ToString());
  end;

  case Key of
    vkLeft  : LImpulse := Point3D(-1, 0, 0);
    vkRight : LImpulse := Point3D(1, 0, 0);
    vkUp    : LImpulse := Point3D(0, -1, 0);
    vkDown  : LImpulse := Point3D(0, 1, 0);
    else LImpulse := TPoint3D.Zero;
  end;

  GorillaPhysicsSystem1.RemoteBodyImpulse(GorillaSphere1, LImpulse);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if not GorillaPhysicsSystem1.Async then
    GorillaPhysicsSystem1.Step();

  GorillaViewport1.Invalidate();
end;

end.
